import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Line3D implements Drawable3D {

    private Point3D p1, p2;

    public Line3D(Point3D p1, Point3D p2) {
        // det är vikitgt att klona värdena som kommer in så att vi
        // är säkra på att ingen annan har en pekare till vårt
        // interna state som vi antar att vi äger.
        this.p1 = p1.clone();
        this.p2 = p2.clone();
    }

    public void draw(Graphics g, int width, int height) {
        g.drawLine((int)(p1.getX()) + width/2, -(int)(p1.getY()) + height/2,
                   (int)(p2.getX()) + width/2, -(int)(p2.getY()) + height/2);
    }

    public Line3D rotate(double xy_angle, double yz_angle) {
        // return new Line3D(p1.rotate(xy_angle,yz_angle),
        //                   p2.rotate(xy_angle,yz_angle));
        p1.rotate(xy_angle,yz_angle);
        p2.rotate(xy_angle,yz_angle);
        return this;
    }

    public Line3D translate(double x, double y, double z) {
        // return new Line3D(p1.translate(x,y,z),p2.translate(x,y,z));
        p1.translate(x,y,z);
        p2.translate(x,y,z);
        return this;
    }

    public Line3D clone() {
        // vi klonar inte p1 och p2 här för att dessa blir genast
        // klonade när de kommer in i konstruktorn.
        return new Line3D(p1,p2);
    }

}
