import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Many3D implements Drawable3D {

    private Drawable3D p1;
    private Drawable3D p2;

    public Many3D(Drawable3D p1, Drawable3D p2) {
        // det är vikitgt att klona värdena som kommer in så att vi
        // är säkra på att ingen annan har en pekare till vårt
        // interna state som vi antar att vi äger.
        this.p1 = (Drawable3D) p1.clone();
        this.p2 = (Drawable3D) p2.clone();
    }

    public Drawable3D rotate(double xy_angle, double yz_angle) {
        // return new Many3D(p1.rotate(xy_angle,yz_angle),
        //                   p2.rotate(xy_angle,yz_angle));
        p1.rotate(xy_angle,yz_angle);
        p2.rotate(xy_angle,yz_angle);
        return this;
    }

    public void draw(Graphics g, int width, int height) {
        p1.draw(g,width,height);
        p2.draw(g,width,height);
    }

    public Drawable3D translate(double x, double y, double z) {
        // return new Many3D(p1.translate(x,y,z),p2.translate(x,y,z));
        p1.translate(x,y,z);
        p2.translate(x,y,z);
        return this;
    }

    public Many3D clone() {
        // vi klonar inte p1 och p2 här för att dessa blir genast
        // klonade när de kommer in i konstruktorn.
        return new Many3D(p1,p2);
    }

}
